/*

Mike DeFehr Sept, 2009
mike@defehr.com
http://mikedefehr.com
http://winnipeg.sqlpass.org/

*/
USE tempdb
IF OBJECT_ID('Things') IS NOT NULL DROP TABLE Things
CREATE TABLE Things
(	ThingID int IDENTITY(1,1) PRIMARY KEY,
	ThingDescription varchar(255)
)
IF OBJECT_ID('ThingInsertLog') IS NOT NULL DROP TABLE ThingInsertLog
CREATE TABLE ThingInsertLog
(	ThingID int,
	InsertDateTime datetime
)







INSERT ThingInsertLog (ThingID, InsertDateTime)
SELECT ThingID, CURRENT_TIMESTAMP
FROM
(	
	INSERT Things(ThingDescription) 
	OUTPUT inserted.ThingID
	VALUES
	('Book'),('Door'),('Heater')
) a

SELECT * FROM Things
SELECT * FROM ThingInsertLog




--ALTER TABLE ThingInsertLog ADD CONSTRAINT FK_til_t FOREIGN KEY (ThingID) REFERENCES Things (ThingID)

--Example 2: performance

IF OBJECT_ID('InsPerf') IS NOT NULL DROP TABLE InsPerf
CREATE TABLE InsPerf (
	InsPerfID int PRIMARY KEY,
	SomeData varchar(255)
	)
CREATE INDEX ix_InsPerf_SomeData ON InsPerf (SomeData)

IF OBJECT_ID('CurrentIDNum') IS NOT NULL DROP TABLE CurrentIDNum
CREATE TABLE CurrentIDNum (
	TableName sysname PRIMARY KEY,
	CurrentIDNumValue int NOT NULL
	)
GO	
INSERT CurrentIDNum VALUES ('InsPerf',0)
SELECT * FROM InsPerf
SELECT * FROM CurrentIDNum
GO


IF OBJECT_ID('InsPerf_ins_sp') IS NOT NULL DROP PROC InsPerf_ins_sp
GO
CREATE PROC InsPerf_ins_sp
@SomeData varchar(255)
AS
SET NOCOUNT ON
DECLARE @IDNum int

BEGIN TRANSACTION
UPDATE c SET CurrentIDNumValue += 1 FROM CurrentIDNum c WHERE TableName = 'InsPerf'

SELECT @IDNum = CurrentIDNumValue FROM CurrentIDNum WHERE TableName = 'InsPerf'

INSERT InsPerf (InsPerfID, SomeData) VALUES (@IDNum, @SomeData)
COMMIT TRANSACTION

GO


EXEC InsPerf_ins_sp 'Test 1'
SELECT * FROM InsPerf
SELECT * FROM CurrentIDNum

EXEC InsPerf_ins_sp 'Test 2'
SELECT * FROM InsPerf
SELECT * FROM CurrentIDNum




IF OBJECT_ID('InsPerf_ins_sp') IS NOT NULL DROP PROC InsPerf_ins_sp
GO
CREATE PROC InsPerf_ins_sp
@SomeData varchar(255)
AS
SET NOCOUNT ON
DECLARE @IDNum int

BEGIN TRANSACTION
UPDATE CurrentIDNum SET @IDNum = CurrentIDNumValue = CurrentIDNumValue + 1 WHERE TableName = 'InsPerf'

INSERT InsPerf (InsPerfID, SomeData) VALUES (@IDNum, @SomeData)
COMMIT TRANSACTION
GO

EXEC InsPerf_ins_sp 'Test 3'
SELECT * FROM InsPerf
SELECT * FROM CurrentIDNum

EXEC InsPerf_ins_sp 'Test 4'
SELECT * FROM InsPerf
SELECT * FROM CurrentIDNum
GO

IF OBJECT_ID('InsPerf_ins_sp') IS NOT NULL DROP PROC InsPerf_ins_sp
GO
CREATE PROC InsPerf_ins_sp
@SomeData varchar(255)
AS
SET NOCOUNT ON

INSERT InsPerf (InsPerfID, SomeData)
SELECT CurrentIDNumValue, @SomeData
FROM
(
	UPDATE CurrentIDNum SET CurrentIDNumValue = CurrentIDNumValue + 1
	OUTPUT inserted.CurrentIDNumValue
	WHERE TableName = 'InsPerf'
) a
GO

EXEC InsPerf_ins_sp 'Test 5'
SELECT * FROM InsPerf
SELECT * FROM CurrentIDNum

EXEC InsPerf_ins_sp 'Test 6'
SELECT * FROM InsPerf
SELECT * FROM CurrentIDNum
GO


/* perf testing
DECLARE @StopTime datetime = DATEADD(second,30,CURRENT_TIMESTAMP)
WHILE  CURRENT_TIMESTAMP < @StopTime
	EXEC InsPerf_ins_sp 'Test 1'

SELECT SomeData, COUNT(*) FROM InsPerf GROUP BY SomeData COMPUTE SUM(COUNT(*))
*/